-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript legt die Projektdatenbank an. Es wird durch weitere Skripte       ##
-- ## ergnzt, die in ihrer durchnummerierten Reihenfolge abzuarbeiten sind. Die      ##
-- ## Skripte passen zu den Aufgabenstellungen aus der zugehrigen Powerpoint-        ##
-- ## Prsentation vom selben Autor.                                                  ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- allgemeine Datenbank als Startpunkt whlen, die es IMMER gibt
USE [master]
GO

-----------------------------
-- Aufrumarbeiten ----------
-----------------------------
-- bestehende Datenbank Workshop_Kopfnuesse lschen, um sauber wieder aufzusetzen
DROP DATABASE IF EXISTS [Workshop_Kopfnuesse];
GO


-- Anlage der Datenbank Workshop_Kopfnuesse. Hier sollen alle weiteren Schritte stattfinden, um evtl. vorhandene 
-- Nutzerdatenbanken nicht zu gefhrden. Die Pfade sind fr die eigene Verwendung evtl. anzupassen!
CREATE DATABASE [Workshop_Kopfnuesse]
 CONTAINMENT = NONE
 ON  PRIMARY 
( NAME = N'Workshop_Kopfnuesse', FILENAME = N'C:\Temp\Workshop_Kopfnuesse.mdf' , SIZE = 8192KB , MAXSIZE = UNLIMITED, FILEGROWTH = 65536KB )
 LOG ON 
( NAME = N'Workshop_Kopfnuesse_log', FILENAME = N'C:\Temp\Workshop_Kopfnuesse_log.ldf' , SIZE = 8192KB , MAXSIZE = 2048GB , FILEGROWTH = 65536KB )
GO

IF (1 = FULLTEXTSERVICEPROPERTY('IsFullTextInstalled'))
begin
EXEC [Workshop_Kopfnuesse].[dbo].[sp_fulltext_database] @action = 'enable'
end
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET ANSI_NULL_DEFAULT OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET ANSI_NULLS OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET ANSI_PADDING OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET ANSI_WARNINGS OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET ARITHABORT OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET AUTO_CLOSE OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET AUTO_SHRINK OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET AUTO_UPDATE_STATISTICS ON 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET CURSOR_CLOSE_ON_COMMIT OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET CURSOR_DEFAULT  GLOBAL 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET CONCAT_NULL_YIELDS_NULL OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET NUMERIC_ROUNDABORT OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET QUOTED_IDENTIFIER OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET RECURSIVE_TRIGGERS OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET  DISABLE_BROKER 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET AUTO_UPDATE_STATISTICS_ASYNC OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET DATE_CORRELATION_OPTIMIZATION OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET TRUSTWORTHY OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET ALLOW_SNAPSHOT_ISOLATION OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET PARAMETERIZATION SIMPLE 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET READ_COMMITTED_SNAPSHOT OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET HONOR_BROKER_PRIORITY OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET RECOVERY FULL 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET  MULTI_USER 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET PAGE_VERIFY CHECKSUM  
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET DB_CHAINING OFF 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET FILESTREAM( NON_TRANSACTED_ACCESS = OFF ) 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET TARGET_RECOVERY_TIME = 60 SECONDS 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET DELAYED_DURABILITY = DISABLED 
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET QUERY_STORE = OFF
GO

ALTER DATABASE [Workshop_Kopfnuesse] SET  READ_WRITE 
GO

