-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript legt die Tabellen fr die Aufgabe OKTOBERFEST an. Es wird durch   ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu-       ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Workshop_Kopfnuesse]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-----------------------------
-- Aufrumarbeiten ----------
-----------------------------
-- bestehende Prozedur SPASSGELDAUSGEBEN im Schema OKTOBERFEST lschen, um sauber wieder aufzusetzen
DROP PROCEDURE IF EXISTS [Oktoberfest].[SpassgeldAusgeben]
GO

-- bestehende Tabelle ATTRAKTION im Schema OKTOBERFEST lschen, um sauber wieder aufzusetzen
DROP TABLE IF EXISTS [Oktoberfest].[Attraktion]
GO

-- bestehendes Schema OKTOBERFEST lschen, um sauber wieder aufzusetzen
DROP SCHEMA  IF EXISTS [Oktoberfest]
GO


-----------------------------
-- Aufbauarbeiten ----------
-----------------------------
-- Schema OKTOBERFEST anlegen, um Objekte sauber der Aufgabe zuordnen zu knnen
CREATE SCHEMA [Oktoberfest]
GO

-- Tabelle ATTRAKTION im Schema OKTOBERFEST anlegen
CREATE TABLE [Oktoberfest].[Attraktion](
	  [ID]			[INT] PRIMARY KEY IDENTITY(1,1)
	, [Attraktion]	[NVARCHAR](20)							NULL
	, [Preis]		[MONEY]									NULL
) ON [PRIMARY]
GO

-- Tabelle ATTRAKTION im Schema OKTOBERFEST mit den Inhalten aus der Powerpoint-Prsentation fllen
INSERT INTO [Oktoberfest].[Attraktion] VALUES 
    ('Kettenkarussell',		2.15)
  , ('Geisterbahn',			4.50)
  , ('Raupe',				2.80)
  , ('Wrstchenstand',		4.20)
  , ('Softgetrnk',			1.75)
  , ('Riesenrad',		    5.30)
  , ('Autoscooter',		    3.10)
  , ('Entenangeln',			2.40)
  , ('Dosenwerfen',		    2.05)
  , ('Losbude',				1.55)
  , ('Wilde Maus',			4.30)
  , ('Kamelrennen',			1.60)
  

