-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript bietet eine mgliche Lsung fr die Aufgabe KALENDER. Es wird     ##
-- ## durch weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu- ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Workshop_Kopfnuesse]
GO


-- Phasen ohne Lcken (= Server online)
SELECT 
	  COUNT(*)																	AS [AnzahlTage]
	, MIN([Tag])																AS [Startdatum]
	, MAX([Tag])																AS [Enddatum]
FROM
(
	SELECT
		[Tag]																	AS [Tag]
		-- mit "row_number" eine knstliche, garantiert lckenlos fortlaufende Zhlspalte einfgen
	  , row_number() OVER (ORDER BY [Tag])										AS [lfdNummer]
	  , datediff(day,'20171231', [Tag])											AS [TagDesJahres]
	  -- "springt" der Abstand zwischen knstlicher Zhlspalte und dem Tag des Jahres --> Lcke gefunden
	  , datediff(day,'20171231', [Tag]) - row_number() OVER (ORDER BY [Tag])	AS [Differenz]
	FROM [Kalender].[Jahrestage]
) as Dummy
GROUP BY [Differenz]
ORDER BY [AnzahlTage] DESC, [Startdatum] ASC
-- ORDER BY [Startdatum] ASC














-- nur die Lcken (bspw. Server offline)
SELECT
	  [aktuellerTag]																AS [letzterTagVorLuecke]
	, [naechsterTag]																AS [naechsterTagNachLuecke]
	, datediff(day, [aktuellerTag], [naechsterTag]) - 1								AS [LueckeInTagen]
FROM
	(
	SELECT 
		-- aktueller Abfragetag
		  [Tag]																		AS [aktuellerTag]
		-- Nachfolger (LEAD) des aktuellen Abfragetages
		, LEAD([Tag]) OVER (ORDER BY [Tag])											AS [naechsterTag]
		, DATEDIFF(day, [Tag], LEAD([Tag]) OVER (ORDER BY [Tag]))					AS [Differenz]
	FROM [Kalender].[Jahrestage]
	) AS Dummy
WHERE 1=1
	-- liegt der Abfragetag nicht genau einen Tag vor seinem eigenen Nachfolger --> Lcke!
	AND [Differenz] > 1
ORDER BY [LueckeInTagen] DESC, [letzterTagVorLuecke] ASC

