-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst - Version 2.0>   ##     
-- #####################################################################################
-- ## Dieses Skript legt die Objekte zru Aufgabe "Grillgutkette" an. Es wird durch    ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge             ##
-- ## abzuarbeiten sind. Die Skripte passen zu den Aufgabenstellungen aus der         ##
-- ## zugehrigen Powerpoint-Prsentation vom selben Autor.                           ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- "richtige" Datenbank auswhlen
USE [Workshop_Kopfnuesse]
GO


SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


-- ######################################################################################
-- 1. Teil: Die Spalte BEZEICHNUNG zu einer Liste verketten
-- ######################################################################################

-- Es gilt, die Eintrge in der Spalte BEZEICHNUNG in eine Zeile als kommaseparierte Liste 
-- zu bekommen. Am Ende der Liste darf kein Komma mehr stehen. Hierfr sind divere 
-- Mglichketen denkbar, u.a:

-- #########################################################
-- 1 Teil, Variante a: "dummer Cursor" - so BITTE NICHT!
-- #########################################################

DECLARE @Zwischenspeicher				VARCHAR(30)
DECLARE @Ergebnis						VARCHAR(8000)
DECLARE DummerCursor					CURSOR FOR SELECT [Grillgut] FROM [Kette].[vGrillgut]

OPEN DummerCursor
FETCH NEXT FROM DummerCursor INTO @Zwischenspeicher

WHILE @@FETCH_STATUS = 0
BEGIN
	SET @Ergebnis = COALESCE(@Ergebnis + ', ','') + @Zwischenspeicher
	FETCH NEXT FROM DummerCursor into @Zwischenspeicher
END

CLOSE DummerCursor
DEALLOCATE DummerCursor

SELECT @Ergebnis		AS[Grillgut]
GO
-- ACHTUNG: Hier werden logischerweise bestimmte Bezeichner mehrfach aufgelistet, da einfach nur die Inhalte 
-- aller Zeilen hintereinandergehngt werden

-- #########################################################
-- 1 Teil, Variante b: "Abflachfunktion" - so BITTE NICHT!
-- #########################################################
CREATE OR ALTER FUNCTION [Kette].[Abflachen]()
RETURNS VARCHAR(8000)
AS
	BEGIN
		DECLARE @Zwischenergebnis VARCHAR(8000)
		SELECT @Zwischenergebnis = ISNULL( @Zwischenergebnis + ', ', '' ) + [Grillgut] 
		FROM [Kette].[vGrillgut]

		RETURN @Zwischenergebnis
	END
GO

SELECT [Kette].[Abflachen]() AS [Grillgut]
GO
-- ACHTUNG: Hier werden logischerweise bestimmte Bezeichner mehrfach aufgelistet, da einfach nur die Inhalte 
-- aller Zeilen hintereinandergehngt werden



-- #########################################################
-- 1 Teil, Variante C: Set-basierte Lsung - so BITTE NICHT!
-- #########################################################
DECLARE @Zwischenergebnis VARCHAR(8000)
SELECT 
	@Zwischenergebnis = ISNULL( @Zwischenergebnis + ', ', '' ) + [Grillgut] 
FROM 
	[Kette].[vGrillgut]
SELECT 
	@Zwischenergebnis			AS [Grillgut]
GO
-- ACHTUNG: Hier werden logischerweise bestimmte Bezeichner mehrfach aufgelistet, da einfach nur die Inhalte 
-- aller Zeilen hintereinandergehngt werden



-- oder

-- Die STUFF-Funktion fgt eine Zeichenfolge in eine andere Zeichenfolge ein. Sie lscht ab einer bestimmten 
-- Anfangsposition eine festgelegte Anzahl von Zeichen in der ersten Zeichenfolge und fgt dort die zweite Zeichenfolge ein.
DECLARE @Zwischenergebnis VARCHAR(8000)
SET @Zwischenergebnis = ''

SELECT @Zwischenergebnis = @Zwischenergebnis + ', ' + [Grillgut]
FROM [Kette].[vGrillgut]

SELECT STUFF(@Zwischenergebnis, 1, 2, '') 			AS [Grillgut]
GO
-- ACHTUNG: Hier werden logischerweise bestimmte Bezeichner mehrfach aufgelistet, da einfach nur die Inhalte 
-- aller Zeilen hintereinandergehngt werden




-- oder

DECLARE @Zwischenergebnis		VARCHAR(1000)
SET @Zwischenergebnis = ''
SELECT
    @Zwischenergebnis = @Zwischenergebnis + [Grillgut] + ', '
FROM
    [Kette].[vGrillgut]
SELECT
    LEFT(@Zwischenergebnis, LEN (@Zwischenergebnis)-1)		AS [Grillgut]
GO


-- #########################################################
-- Tei 2: Nun muss auch nach GASTNAME gruppiert werden
-- #########################################################


-- Informationen ber Verwendung des "FOR XML PATH(''):
-- https://docs.microsoft.com/de-de/sql/relational-databases/xml/for-xml-sql-server?view=sql-server-ver15
-- Mit diesem "Trick" lt sich auch die Grenbegrenzung (8000 Zeichen) des VARCHAR-Datetyps umgehen

SELECT
	  [Gastname]												AS [Gastname]
	, [Grillgut-Liste]											AS [Grillgut-Liste]
FROM
	(

	SELECT 
		  [Gastname]
		, LEFT([Grillgut-Liste], LEN([Grillgut-Liste])-1)		AS [Grillgut-Liste]
	  FROM [Kette].[Grillgut] [GGK]

	  CROSS APPLY

	  (SELECT CONVERT(VARCHAR(2), [Anzahl]) + ' ' + CAST([Bezeichnung] AS NVARCHAR(30)) + ', '
		FROM [Kette].[Grillgut] [GGK_CA]
	   WHERE [GGK].[Gastname] = [GGK_CA].[Gastname]
		 FOR XML PATH('')) AS x([Grillgut-Liste])
	) [IrgendEinDummyName]

GROUP BY [Gastname], [Grillgut-Liste]