-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript legt die Prozeduren fr die Aufgabe "8 Damen" an. Es wird durch   ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu-       ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr..                                                  ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- #####################################################################################
-- ### Laufzeit auf diesem System ca. 21:02 Minuten                                  ###
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Workshop_Kopfnuesse]

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


-- Es wird eine temporre Tabelle angelegt, in der nur die Felder durchnummeriert werden
-- In unserem Beispiel wollen wir 8 Damen auf ein 8x8-Feld platzieren, also bentigen 
-- wir die Ziffern 1 - 8 in dieser Tabelle
SELECT *
INTO [#TEST]
FROM (VALUES (1), (2), (3), (4), (5), (6), (7), (8))
t(X)


-- Nun sorgen wir dafr, dass in einer weiteren temporren Tabelle jede Kombination von den 
-- Spalten 1-8 mit den Zeilen 1-8 landen. Hierfr nutzen wir einen CROSSJOIN, verknpfen also 
-- jeden Datensatz der ertsen mit jedem Datensatz der zweiten Tabelle (die wieder die erste 
-- Tabelle unter neuem Alias-Namen ist).
SELECT   [t1].[X]      AS [X]
       , [t2].[X]      AS [Y]
INTO [#test2]
FROM [#TEST] [t1], [#TEST] [t2]


-- Jetzt geben wir diese Werte als Ergebnis aus - jeweils 8 verschiedene Spalten werden 
-- zu einem Zeilensatz verknpft.
-- Dabei filtern wir ber die WHERE-Bedingungen die Datenstez aus, die gegen die 
-- Spielregeln verstoen.
SELECT 
       CHAR(64 + [t1].[X]) + CONVERT(CHAR(1), [t1].[Y]) + ' + ' +
       CHAR(64 + [t2].[X]) + CONVERT(CHAR(1), [t2].[Y]) + ' + ' +
       CHAR(64 + [t3].[X]) + CONVERT(CHAR(1), [t3].[Y]) + ' + ' +
       CHAR(64 + [t4].[X]) + CONVERT(CHAR(1), [t4].[Y]) + ' + ' +
       CHAR(64 + [t5].[X]) + CONVERT(CHAR(1), [t5].[Y]) + ' + ' +
       CHAR(64 + [t6].[X]) + CONVERT(CHAR(1), [t6].[Y]) + ' + ' +
       CHAR(64 + [t7].[X]) + CONVERT(CHAR(1), [t7].[Y]) + ' + ' +
       CHAR(64 + [t8].[X]) + CONVERT(CHAR(1), [t8].[Y])						AS [Loesung]

-- Alle Stze von der temporren Tabelle
FROM [#test2] [t1]

-- zustzlich die Stze, bei denen die zweite Instanz nicht waagerecht, senkrecht oder diagonal zur ersten steht
JOIN [#test2] [t2]  ON	[t1].[X]	<>	[t2].[X]	AND	[t1].[Y]	<>	[t2].[Y]	AND ABS([t1].[X] - [t2].[X])	<>	ABS([t1].[Y] - [t2].[Y])

-- zustzlich die Stze, bei denen die dritte Instanz weder zur ersten noch zur zweiten waagerecht, senkrecht oder diagonal steht
JOIN [#test2] [t3]  ON	[t1].[X]	<>  [t3].[X]	AND	[t1].[Y]	<>	[t3].[Y]	AND ABS([t1].[X] - [t3].[X])	<>	ABS([t1].[Y] - [t3].[Y])
                    AND	[t2].[X]	<>	[t3].[X]	AND	[t2].[Y]	<>	[t3].[Y]	AND ABS([t2].[X] - [t3].[X])	<>  ABS([t2].[Y] - [t3].[Y])

-- zustzlich die Stze, bei denen keine der Vorinstanzen waagerecht, senkrecht oder diagonal steht
JOIN [#test2] [t4]  ON	[t1].[X]	<>	[t4].[X]	AND	[t1].[Y]	<>	[t4].[Y]	AND ABS([t1].[X] - [t4].[X])	<>	ABS([t1].[Y] - [t4].[Y])
					AND [t2].[X]	<>  [t4].[X]	AND [t2].[Y]	<>  [t4].[Y]	AND ABS([t2].[X] - [t4].[X])	<>	ABS([t2].[Y] - [t4].[Y])
                    AND [t3].[X]	<>  [t4].[X]	AND [t3].[Y]	<>  [t4].[Y]	AND ABS([t3].[X] - [t4].[X])	<>  ABS([t3].[Y] - [t4].[Y])

-- zustzlich die Stze, bei denen keine der Vorinstanzen waagerecht, senkrecht oder diagonal steht
JOIN [#test2] [t5]  ON  [t1].[X]	<>  [t5].[X]	AND [t1].[Y]	<>  [t5].[Y]	AND ABS([t1].[X] - [t5].[X])	<>  ABS([t1].[Y] - [t5].[Y])
					AND [t2].[X]	<>  [t5].[X]	AND [t2].[Y]	<>  [t5].[Y]	AND ABS([t2].[X] - [t5].[X])	<>  ABS([t2].[Y] - [t5].[Y])
					AND [t3].[X]	<>  [t5].[X]	AND [t3].[Y]	<>  [t5].[Y]	AND ABS([t3].[X] - [t5].[X])	<>  ABS([t3].[Y] - [t5].[Y])
					AND [t4].[X]	<>  [t5].[X]	AND [t4].[Y]	<>  [t5].[Y]	AND ABS([t4].[X] - [t5].[X])	<>  ABS([t4].[Y] - [t5].[Y])

-- zustzlich die Stze, bei denen keine der Vorinstanzen waagerecht, senkrecht oder diagonal steht
JOIN [#test2] [t6]  ON  [t1].[X]	<>	[t6].[X]	AND [t1].[Y]	<>  [t6].[Y]	AND ABS([t1].[X] - [t6].[X])	<>  ABS([t1].[Y] - [t6].[Y])
					AND [t2].[X]	<>	[t6].[X]	AND	[t2].[Y]	<>	[t6].[Y]	AND ABS([t2].[X] - [t6].[X])	<>  ABS([t2].[Y] - [t6].[Y])
					AND [t3].[X]	<>	[t6].[X]	AND	[t3].[Y]	<>	[t6].[Y]	AND ABS([t3].[X] - [t6].[X])	<>  ABS([t3].[Y] - [t6].[Y])
					AND [t4].[X]	<>	[t6].[X]	AND	[t4].[Y]	<>	[t6].[Y]	AND ABS([t4].[X] - [t6].[X])	<>  ABS([t4].[Y] - [t6].[Y])
					AND [t5].[X]	<>	[t6].[X]	AND	[t5].[Y]	<>	[t6].[Y]	AND ABS([t5].[X] - [t6].[X])	<>  ABS([t5].[Y] - [t6].[Y])

-- 7. Dame: zustzlich die Stze, bei denen keine der Vorinstanzen waagerecht, senkrecht oder diagonal steht
JOIN [#test2] [t7]  ON  [t1].[X]	<>	[t7].[X]	AND	[t1].[Y]	<>  [t7].[Y]	AND ABS([t1].[X] - [t7].[X])	<>	ABS([t1].[Y] - [t7].[Y])
					AND [t2].[X]	<>	[t7].[X]	AND	[t2].[Y]	<>	[t7].[Y]	AND ABS([t2].[X] - [t7].[X])	<>  ABS([t2].[Y] - [t7].[Y])
					AND [t3].[X]	<>	[t7].[X]	AND	[t3].[Y]	<>	[t7].[Y]	AND ABS([t3].[X] - [t7].[X])	<>  ABS([t3].[Y] - [t7].[Y])
					AND [t4].[X]	<>	[t7].[X]	AND	[t4].[Y]	<>	[t7].[Y]	AND ABS([t4].[X] - [t7].[X])	<>  ABS([t4].[Y] - [t7].[Y])
					AND [t5].[X]	<>	[t7].[X]	AND	[t5].[Y]	<>	[t7].[Y]	AND ABS([t5].[X] - [t7].[X])	<>  ABS([t5].[Y] - [t7].[Y])
					AND [t6].[X]	<>	[t7].[X]	AND	[t6].[Y]	<>	[t7].[Y]	AND ABS([t6].[X] - [t7].[X])	<>  ABS([t6].[Y] - [t7].[Y])

JOIN [#test2] [t8]  ON	[t1].[X]	<>	[t8].[X]	AND	[t1].[Y]	<>	[t8].[Y]	AND ABS([t1].[X] - [t8].[X])	<>	ABS([t1].[Y] - [t8].[Y])
					AND [t2].[X]	<>	[t8].[X]	AND	[t2].[Y]	<>	[t8].[Y]	AND ABS([t2].[X] - [t8].[X])	<>  ABS([t2].[Y] - [t8].[Y])
					AND [t3].[X]	<>	[t8].[X]	AND	[t3].[Y]	<>	[t8].[Y]	AND ABS([t3].[X] - [t8].[X])	<>  ABS([t3].[Y] - [t8].[Y])
					AND [t4].[X]	<>	[t8].[X]	AND	[t4].[Y]	<>	[t8].[Y]	AND ABS([t4].[X] - [t8].[X])	<>  ABS([t4].[Y] - [t8].[Y])
					AND [t5].[X]	<>	[t8].[X]	AND	[t5].[Y]	<>	[t8].[Y]	AND ABS([t5].[X] - [t8].[X])	<>  ABS([t5].[Y] - [t8].[Y])
					AND [t6].[X]	<>	[t8].[X]	AND	[t6].[Y]	<>	[t8].[Y]	AND ABS([t6].[X] - [t8].[X])	<>  ABS([t6].[Y] - [t8].[Y])
					AND [t7].[X]	<>	[t8].[X]	AND	[t7].[Y]	<>	[t8].[Y]	AND ABS([t7].[X] - [t8].[X])	<>  ABS([t7].[Y] - [t8].[Y])

WHERE 1 = 1

-- ----------------------------------------------------------------------------------------------------------------------------
-- Optimierung: Wenn in der Lsung keine Vertauschungen zugelassen werden, reduziert sich die Zahl der Lsungen 
-- von ber 32.000 auf 92 und die Laufzeit von 21:02 Minuten auf 16 Sekunden 
-- (auf meinem Laptop Intel-i7-855OU@1.80GHz (1.99 GHz)64Bit Windows, 8GB RAM)
--                 ---------------------
-- immer noch enthalten sind Spiegelungen, Drehungen, ... Diese zu eleminieren ist ebenfalls per T-SQL mglich,
-- wird in diser Session aber NICHT behandelt. Der Aufwand wrde deutlich steigen, die Laufzeit entsprechend ebenfalls.
-- ----------------------------------------------------------------------------------------------------------------------------
	AND [t1].[X] < [t2].[X]
	AND [t2].[X] < [t3].[X]
	AND [t3].[X] < [t4].[X]
	AND [t4].[X] < [t5].[X]
	AND [t5].[X] < [t6].[X]
	AND [t6].[X] < [t7].[X]
	AND [t7].[X] < [t8].[X]

-- ----------------------------------------------------------------------------------------------------------------------------
-- auskommentierte Testroutine: eine bekannte Lsung zur Kontrolle des Statements, diese lsst sich 
-- schrittweise ein- und auskommentieren, um Zwischenergebnisse darauf hin abzuklopfen, ob mindestens 
-- diese Lsung noch enthalten ist
-- ----------------------------------------------------------------------------------------------------------------------------
    --AND [t1].[X] = 1      AND [t1].[Y] = 1
    --AND [t2].[X] = 2      AND [t2].[Y] = 5
    --AND [t3].[X] = 3      AND [t3].[Y] = 8
    --AND [t4].[X] = 4      AND [t4].[Y] = 6
    --AND [t5].[X] = 5      AND [t5].[Y] = 3
    --AND [t6].[X] = 6      AND [t6].[Y] = 7
    --AND [t7].[X] = 7      AND [t7].[Y] = 2

ORDER BY 1

               DROP TABLE [#test]
               DROP TABLE [#test2]

