-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript legt die Tabellen fr die Aufgabe "RubiksCube" an. Es wird durch  ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu-       ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Workshop_Kopfnuesse]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO





-------------------------------------------------------------------------------------------
-- Anlage eines eigenen Schemas fr diese Aufgabe
-------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 1 FROM sys.schemas WHERE name = 'RubiksCube')
BEGIN
	EXECUTE('CREATE SCHEMA [RubiksCube]')
END
GO 




-------------------------------------------------------------------------------------------
-- Anlage der Tabelle fr die Bewegungsstze
-------------------------------------------------------------------------------------------
IF (EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'RubiksCube' AND  TABLE_NAME = 'Bewegungssatz'))
BEGIN
    DROP TABLE [RubiksCube].[Bewegungssatz]
END

CREATE TABLE [RubiksCube].[Bewegungssatz]
(
	  [ID]						[BIGINT]		IDENTITY (1,1)	NOT NULL
	, [Ausgangsposition]		[CHAR](24)						NOT NULL
	, [Bewegung]				[VARCHAR](25)					NOT NULL
	, [Zielposition]			[CHAR](24)						NOT NULL
--	, [NormZielposition]		[CHAR](24)						NOT NULL
	, [istabgearbeitet]			[BIT]							NOT NULL
)
GO






-------------------------------------------------------------------------------------------
-- Anlage der Tabelle fr die Zugkombinationen
-------------------------------------------------------------------------------------------
IF (EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES  WHERE TABLE_SCHEMA = 'RubiksCube' AND  TABLE_NAME = 'ZugKombinationen'))
BEGIN
    DROP TABLE [RubiksCube].[ZugKombinationen]
END

CREATE TABLE [RubiksCube].[ZugKombinationen](
	  [ID]						[BIGINT]		IDENTITY (1,1)	NOT NULL
	, [Ausgangsposition]		[char](24)						NOT NULL
	, [Bewegung]				[varchar](25)					NOT NULL
	, [Zielposition]			[char](24)						NOT NULL
--	, [NormZielposition]		[CHAR](24)						NOT NULL
	, [istabgearbeitet]			[bit]							NOT NULL,
CONSTRAINT [PK_ZugKombinationen] PRIMARY KEY CLUSTERED 
(
	  [Ausgangsposition]		ASC
	, [Zielposition]			ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO



