-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript legt die Tabellen fr die Aufgabe "RubiksCube" an. Es wird durch  ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu-       ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Workshop_Kopfnuesse]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO




/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     R     /     R     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| Y |
  /		W     /	    W     /	|  	o				     /		R    /	    R    / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | Y |   |
|     G     |     G     |  /| R |				   |     G     |     G     |  /| Y |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | Y |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     G     |     G     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/

-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht diesen Wrfel dann um 90    --
-- gegen den Uhrzeigersinn und gibt die neue Wrfel-ID wieder aus.                  --
-- -----------------------------------------------------------------------------------
-- Beispiel:        'WWWWGGRRBBOOGGRRBBOOYYYY' - Ausgangswrfel                     --
--					'BBBBWWRRYYOOWWRRYYOOGGGG' - nach der Drehung                   --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncKippe90GradLinks] 
(
	@Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
	DECLARE @Rueckgabewert     AS VARCHAR(24) = ''
	SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition ,  9,  2)
	SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 17,  2)
	SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  1,  2)
	SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  7,  2)
	SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 21,  2)
	SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 11,  2)
	SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  3,  2)
	SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 15,  2)
	SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 23,  2)
	SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 19,  2)
	SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  5,  2)
	SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 13,  2)
	RETURN @Rueckgabewert
END
GO




/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     G     /     G     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| R |
  /		W     /	    W     /	|  	o				     /		G    /	    G    / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | R |   |
|     G     |     G     |  /| R |				   |     B     |     B     |  /| R |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | R |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     B     |     B     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/
-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht diesen Wrfel dann um 90    --
-- nach hinten und gibt die neue Wrfel-ID wieder aus.                              --
-- -----------------------------------------------------------------------------------
-- Beispiel:          'WWWWGGRRBBOOGGRRBBOOYYYY' - Ausgangswrfel                   --
--                    'RRRRGGYYBBWWGGYYBBWWOOOO' - nach der Drehung                 --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncKippe90GradHoch] 
(
	@Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
    DECLARE @Rueckgabewert     AS VARCHAR(24) = ''
    SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition ,  5,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 13,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 21,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  7,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  9,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  1,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 23,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 15,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 17,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  3,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 11,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 19,  2)
    RETURN @Rueckgabewert
END
GO






-------------------------------------------------------------------------------------------
-- Diese Prozdedur sucht aus allen mglichen Ausrichtungen des selben Wrfels diejenige 
-- mit der kleinsten ID-Darstellung raus
-------------------------------------------------------------------------------------------
CREATE OR ALTER PROCEDURE [RubiksCube].[prcKleinstePositionsID] 
(
	  @Eingangsposition							CHAR(24)
    , @Rueckgabewert							VARCHAR(24)					OUT
)
AS
BEGIN

	SET NOCOUNT ON
	
    DECLARE @AktuellePositionID					CHAR(24)

    CREATE TABLE [RubiksCube].[#AllSeitenBetrachtung]
    (
        [WuerfelID]								CHAR(24)		NOT NULL
    ) ON [PRIMARY]

                SET @AktuellePositionID = @Eingangsposition
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- 90 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- insgesamt 180 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- insgesamt 270 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)

                SET @AktuellePositionID = @Eingangsposition
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradHoch](@AktuellePositionID)                 
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- 90 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- insgesamt 180 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- insgesamt 270 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)

                SET @AktuellePositionID = @Eingangsposition
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradHoch](@AktuellePositionID)                 
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradHoch](@AktuellePositionID)                 
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- 90 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- insgesamt 180 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- insgesamt 270 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)

                SET @AktuellePositionID = @Eingangsposition
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradHoch](@AktuellePositionID)                 
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradHoch](@AktuellePositionID)                 
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradHoch](@AktuellePositionID)                 
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- 90 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- insgesamt 180 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- insgesamt 270 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)

                SET @AktuellePositionID = @Eingangsposition
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradHoch](@AktuellePositionID)                 
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- 90 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- insgesamt 180 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- insgesamt 270 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)

                SET @AktuellePositionID = @Eingangsposition
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradHoch](@AktuellePositionID)                 
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- 90 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- insgesamt 180 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)
    SET @AktuellePositionID = [RubiksCube].[fncKippe90GradLinks](@AktuellePositionID)                -- insgesamt 270 nach links gekippt
    INSERT INTO [RubiksCube].[#AllSeitenBetrachtung]([WuerfelID]) VALUES(@AktuellePositionID)

    SET @Rueckgabewert = (SELECT TOP 1 [WuerfelID] FROM [RubiksCube].[#AllSeitenBetrachtung] ORDER BY [WuerfelID])
END
GO


